// CatalogWrapper : Declaration of the CCatalogWrapper

#ifndef __CATALOG_WRAPPER_
#define __CATALOG_WRAPPER_
     
#include "resource.h"       // main symbols
#include "ES2.h"

/////////////////////////////////////////////////////////////////////////////
// CCatalogWrapper
class  CCatalogWrapper : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CCatalogWrapper,&CLSID_CatalogWrapper>,
   public ITransientSubscription,
	public IFilterInstaller
{
public:
	CCatalogWrapper();
	~CCatalogWrapper();
   HRESULT FinalConstruct();
   void FinalRelease();

   DECLARE_REGISTRY_RESOURCEID(IDR_CATALOGWRAPPER)

   DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CCatalogWrapper)
	COM_INTERFACE_ENTRY(ITransientSubscription)
	COM_INTERFACE_ENTRY(IFilterInstaller)
END_COM_MAP()

public:
// ITransientSubscription
   STDMETHOD(Add)(LPCWSTR pwzSubName,CLSID clsidEventClass,REFIID iidInterface,IUnknown *pSink);
   STDMETHOD(Remove)(LPCWSTR pwzSubName);
   STDMETHOD(AddFilter)(LPCWSTR pwzSubName,LPCWSTR pwzCriteria);
   STDMETHOD(RemoveFilter)(LPCWSTR pwzSubName);

// IFilterInstaller
   STDMETHOD(Install)(CLSID clsidEventClass,CLSID clsidFilter);
   STDMETHOD(Remove)(CLSID clsidEventClass);
};

#endif //__CATALOG_WRAPPER_

/////////////////////////////////////////////////////////////////////////////
// CCatalogWrapper

