// PublisherDlg.cpp : implementation file
//

#include "stdafx.h"
#include "comdef.h"

#import <es.dll> raw_interfaces_only, raw_native_types, no_namespace, named_guids 

#include "Publisher.h"
#include "PublisherDlg.h"
#include "atlbase.h"
#include "..\EventClass\EventClass.h"
#include "..\EventClass\EventClass_i.c"
#include "..\Subscriber\Subscriber.h"
#include "..\Subscriber\Subscriber_i.c"
#include "..\Filter\Filter.h"
#include "..\Filter\Filter_i.c"
#include "..\es2\es2.h"
#include "..\es2\es2_i.c"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//The name of the transient subscription
LPCWSTR gsSubName = L"My Demo Transient Subscription";




/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}
void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPublisherDlg dialog

CPublisherDlg::CPublisherDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPublisherDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPublisherDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

   m_pMyEvent = NULL;
}
CPublisherDlg::~CPublisherDlg()
{
   HRESULT hres = S_OK;

   OnRemoveTransSub();
   OnRemovePublisherFilter();

   //No need to remove the transient subscriber filter, 
   //since it is gone once the Unsubscribe() is called 
  //OnRemoveTransSubFilter()
}


void CPublisherDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPublisherDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPublisherDlg, CDialog)
	//{{AFX_MSG_MAP(CPublisherDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_PUBLISH, OnPublish)
	ON_BN_CLICKED(IDC_ADD_TRANS_SUB, OnAddTransSub)
	ON_BN_CLICKED(IDC_REMOVE_TRANS_SUB, OnRemoveTransSub)
	ON_BN_CLICKED(IDC_ADD_TRANS_SUB__FILTER, OnAddTransSubFilter)
	ON_BN_CLICKED(IDC_REMOVE_TRANS_SUB__FILTER, OnRemoveTransSubFilter)
	ON_BN_CLICKED(IDC_ADD_PUBLISHER_FILTER, OnAddPublisherFilter)
	ON_BN_CLICKED(IDC_REMOVE_PUBLISHER_FILTER, OnRemovePublisherFilter)
	ON_BN_CLICKED(IDC_ON_PUBLISH, OnPublish)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPublisherDlg message handlers

BOOL CPublisherDlg::OnInitDialog()
{

	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CPublisherDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPublisherDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPublisherDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPublisherDlg::OnPublish() 
{
   
   HRESULT hres = S_OK;

   IMyEvent* pMyEvent = NULL;

   //Create the event class 
   hres = ::CoCreateInstance(CLSID_MyEventClass,NULL,CLSCTX_ALL,IID_IMyEvent,(void**)&pMyEvent);
   ASSERT(SUCCEEDED(hres));

   //Publish
   hres = pMyEvent->Hello();
   if(hres != S_OK)
   {
      _com_error err(hres);
      MessageBox(err.ErrorMessage());
   }
   pMyEvent->Release();
}
void CPublisherDlg::OnAddTransSub() 
{
   HRESULT hres = S_OK;
   ITransientSubscription* pTransientSubscription = NULL;


   m_pMyEvent = NULL;

   //Create the transient subscriber obejct
   hres = ::CoCreateInstance(CLSID_MySubscriber,NULL,CLSCTX_ALL,IID_IMyEvent,(void**)&m_pMyEvent);
   ASSERT(SUCCEEDED(hres));


   //Create the wrapper obejct 
   hres = ::CoCreateInstance(CLSID_CatalogWrapper,NULL,CLSCTX_ALL,IID_ITransientSubscription,(void**)&pTransientSubscription);

   hres = pTransientSubscription->Add(gsSubName,CLSID_MyEventClass,IID_NULL,m_pMyEvent);
   ASSERT(hres == S_OK);

   pTransientSubscription->Release();
}

void CPublisherDlg::OnRemoveTransSub() 
{
   if(NULL == m_pMyEvent)//No transient subscriber created
      return;

   HRESULT hres = S_OK;
   ITransientSubscription* pTransientSubscription = NULL;

   hres = ::CoCreateInstance(CLSID_CatalogWrapper,NULL,CLSCTX_ALL,IID_ITransientSubscription,(void**)&pTransientSubscription);

   hres = pTransientSubscription->Remove(gsSubName);
   ASSERT(hres == S_OK);

   pTransientSubscription->Release();


   m_pMyEvent->Release();
   m_pMyEvent = NULL;
}

void CPublisherDlg::OnAddTransSubFilter() 
{
   if(NULL == m_pMyEvent)//No transient subscriber created
      return;

   HRESULT hres = S_OK;

   ITransientSubscription* pTransientSubscription = NULL;
   hres = ::CoCreateInstance(CLSID_CatalogWrapper,NULL,CLSCTX_ALL,IID_ITransientSubscription,(void**)&pTransientSubscription);

   //Note - this filter is meaningless for this sink interface. Just showing how to use it
   LPCWSTR pwzCriteria = L"bstrUser = \"Bill Gates\"";
   hres = pTransientSubscription->AddFilter(gsSubName,pwzCriteria);
   ASSERT(hres == S_OK);

   pTransientSubscription->Release();
}

void CPublisherDlg::OnRemoveTransSubFilter() 
{
   if(NULL == m_pMyEvent)//No transient subscriber created
      return;

   HRESULT hres = S_OK;

   ITransientSubscription* pTransientSubscription = NULL;
   hres = ::CoCreateInstance(CLSID_CatalogWrapper,NULL,CLSCTX_ALL,IID_ITransientSubscription,(void**)&pTransientSubscription);

   hres = pTransientSubscription->RemoveFilter(gsSubName);
   ASSERT(hres == S_OK);

   pTransientSubscription->Release();
}

void CPublisherDlg::OnAddPublisherFilter() 
{
  
   HRESULT hres = S_OK;
   
   IFilterInstaller* pFilterInstaller = NULL;
   hres = ::CoCreateInstance(CLSID_CatalogWrapper,NULL,CLSCTX_ALL,IID_IFilterInstaller,(void**)&pFilterInstaller);

   hres = pFilterInstaller->Install(CLSID_MyEventClass,CLSID_MyFilter);
   
   ASSERT(hres == S_OK);

   pFilterInstaller->Release();
}

void CPublisherDlg::OnRemovePublisherFilter() 
{
   HRESULT hres = S_OK;
   
   IFilterInstaller* pFilterInstaller = NULL;
   hres = ::CoCreateInstance(CLSID_CatalogWrapper,NULL,CLSCTX_ALL,IID_IFilterInstaller,(void**)&pFilterInstaller);

   hres = pFilterInstaller->Remove(CLSID_MyEventClass);
   ASSERT(hres == S_OK);

   pFilterInstaller->Release();
}
